//////////////////////////////////////////////////////////////////////
//File: Model3ds.cpp
//Create: 2008-1-20
//Author: Kong
//E-Mail: bps-kong@hotmail.com
//Weblog: http://bps-kong.cnblogs.com
//Desc: һ3DSģࡣʵѾУҾʵֵùڸӡ
//      ҲõķʽеXMLPUSHģ͡
//
//Copyleft: ɴ뱣(ע͡˵ĵ)
//////////////////////////////////////////////////////////////////////

#include "Model3ds.h"

CModel3ds::CModel3ds()
{
}

CModel3ds::~CModel3ds()
{
	this->CleanUp();
}

void CModel3ds::CleanUp()
{
	int i;
	for (i=0; i<m_vObjects.size(); i++)
	{
		delete[] m_vObjects[i].pVerts;
		delete[] m_vObjects[i].pTriangles;
		delete[] m_vObjects[i].pTexVerts;
	}
	for (i=0; i<m_vMaterials.size(); i++)
	{
		::glDeleteTextures(1, &m_vMaterials[i].glTexture);
	}
	m_vObjects.clear();
	m_vMaterials.clear();
}

bool CModel3ds::BuildTexture(const char *pFilename, GLuint &glTexture)
{
	// ñдĺȷʵͦ(ʵҺԼдһ^_^)
	int BuildTexture(const char *, GLuint &);
	return BuildTexture(pFilename, glTexture);
}

void CModel3ds::GetObjectVerts(const BYTE* const &pBuf)
{
	// ָ
	const BYTE *pPtr = pBuf;
	// 
	UINT16 nVertCount = *(UINT16*)pPtr; pPtr += sizeof(UINT16);
	// б
	Vector3 *pVerts = new Vector3[nVertCount];
	// 
	//::memcpy((void*)pVerts, (void*)pPtr, nVertCount*sizeof(Vector3));
	for (int i=0; i<nVertCount; i++)
	{
		pVerts[i].x = *(float*)pPtr; pPtr += sizeof(float);
		pVerts[i].z = -(*(float*)pPtr); pPtr += sizeof(float);
		pVerts[i].y = *(float*)pPtr; pPtr += sizeof(float);
	}
	// ǰ
	m_vObjects.back().nVertCount = nVertCount;
	m_vObjects.back().pVerts = pVerts;
}

void CModel3ds::GetObjectTriangles(const BYTE* const &pBuf)
{
	// ָ
	const BYTE *pPtr = pBuf;
	// ĸ
	UINT16 nTriCount = *(UINT16*)pPtr; pPtr += sizeof(UINT16);
	// б
	Triangle *pTriangles = new Triangle[nTriCount];
	// 
	for (int i=0; i<nTriCount; i++)
	{
		pTriangles[i].a = *(UINT16*)pPtr; pPtr += sizeof(UINT16);
		pTriangles[i].b = *(UINT16*)pPtr; pPtr += sizeof(UINT16);
		pTriangles[i].c = *(UINT16*)pPtr; pPtr += sizeof(UINT16);
		// Ϣ
		pPtr += sizeof(UINT16);
	}
	// ǰ
	m_vObjects.back().nTriCount = nTriCount;
	m_vObjects.back().pTriangles = pTriangles;
}

void CModel3ds::GetObjectTexVerts(const BYTE* const &pBuf)
{
	// ָ
	const BYTE *pPtr = pBuf;
	// 
	UINT16 nTexVertCount = *(UINT16*)pPtr; pPtr += sizeof(UINT16);
	// б
	Vector2 *pTexVerts = new Vector2[nTexVertCount];
	// 
	::memcpy((void*)pTexVerts, (void*)pPtr, nTexVertCount*sizeof(Vector2));
	// ǰ
	// m_vObjects.back().nTexVertCount = nTexVertCount;
	m_vObjects.back().pTexVerts = pTexVerts;
}

int CModel3ds::GetObjectName(const BYTE* const &pName)
{
	// ָ
	const char *pPtr = (const char*)pName;

	// ַس
	return ::strlen(::strcpy(m_vObjects.back().csName, pPtr));
}

void CModel3ds::GetMaterialTexture(const BYTE* const &pFilename)
{
	// ָ
	const char *pPtr = (const char*)pFilename;
	char csName[255];

	// ַ
	::strcpy(csName, pPtr);

	// ΪǰϽ
	if (this->BuildTexture(csName, m_vMaterials.back().glTexture)) {
		m_vMaterials.back().bHasTexture = true;
	}
}

int CModel3ds::GetMaterialName(const BYTE* const &pName)
{
	// ָ
	const char *pPtr = (const char*)pName;

	// ַس
	return ::strlen(::strcpy(m_vMaterials.back().csName, pPtr));
}

void CModel3ds::GetObjectMaterial(const BYTE* const &pName)
{
	// ָ
	const char *pPtr = (const char*)pName;
	char csName[255];

	// ַ
	::strcpy(csName, pPtr);

	// в
	for(int i=0; i<m_vMaterials.size(); i++)
	{
		if(0 == ::strcmp(csName, m_vMaterials[i].csName))
		{
			// õǰĲ
			m_vObjects.back().nMaterialId = i;
		}
	}
}

void CModel3ds::GetMaterialColor(const BYTE* const &pBuf)
{
	// ָ
	const BYTE* pPtr = pBuf;
	// ֱָRGBֵ ^_^
	pPtr += sizeof(ChunkHeader);
	// RGBֵ
	::memcpy((void*)(&m_vMaterials.back().oColor), (void*)pPtr, sizeof(Color));
}

void CModel3ds::ProcessChunk(const BYTE* &pChuck, UINT32 nLen)
{
	// ʼǰ
	Object oObject = {0};
	// ʼ޲
	oObject.nMaterialId = -1;
	// ʼǰ
	Material oMaterial = {0};

	// βָ
	const BYTE *pTail = pChuck + nLen;
	while(pChuck <= pTail)
	{
		ChunkHeader *pHeader = (ChunkHeader*)pChuck;
		pChuck += sizeof(ChunkHeader);
		switch (pHeader->nId)
		{
		case 0x4D4D: // PRIMARY
		case 0x3D3D: // PRIMARY -> EDIT
		case 0x4100: // PRIMARY -> EDIT -> OBJECT -> MESH
		case 0xA200: // PRIMARY -> EDIT -> MATERIAL -> MATMAP
			this->ProcessChunk(pChuck, pHeader->nLen);
			break;
		case 0xAFFF: // PRIMARY -> EDIT -> MATERIAL
			m_vMaterials.push_back(oMaterial);
			this->ProcessChunk(pChuck, pHeader->nLen);
			break;
		case 0xA000: // PRIMARY -> EDIT -> MATERIAL -> MATNAME
			this->GetMaterialName(pChuck);
			pChuck += pHeader->nLen - sizeof(ChunkHeader);
			break;
		case 0xA020: // PRIMARY -> EDIT -> MATERIAL -> MATDIFFUSE
			this->GetMaterialColor(pChuck);
			pChuck += pHeader->nLen - sizeof(ChunkHeader);
			break;
		case 0xA300: // PRIMARY -> EDIT -> MATERIAL -> MATMAP -> FILENAME
			this->GetMaterialTexture(pChuck);
			pChuck += pHeader->nLen - sizeof(ChunkHeader);
			break;
		case 0x4000: // PRIMARY -> EDIT -> OBJECT
			m_vObjects.push_back(oObject);
			// ȡ pChuck += GetObjectName(pChuck) + 1;
			this->GetObjectName(pChuck); while (*pChuck++) NULL;
			this->ProcessChunk(pChuck, pHeader->nLen);
			break;
		case 0x4110: // PRIMARY -> EDIT -> OBJECT -> MESH -> VERTEXL
			this->GetObjectVerts(pChuck);
			pChuck += pHeader->nLen - sizeof(ChunkHeader);
			break;
		case 0x4120: // PRIMARY -> EDIT -> OBJECT -> MESH -> FACE
			this->GetObjectTriangles(pChuck);
			// 
			pChuck += sizeof(UINT16) + (*(UINT16*)pChuck)*sizeof(UINT16)*4;
			this->ProcessChunk(pChuck, pHeader->nLen);
			break;
		case 0x4130: // PRIMARY -> EDIT -> OBJECT -> MESH -> FACE -> MATERIAL
			this->GetObjectMaterial(pChuck);
			pChuck += pHeader->nLen - sizeof(ChunkHeader);
			break;
		case 0x4140: // PRIMARY -> EDIT -> OBJECT -> MESH -> UV
			this->GetObjectTexVerts(pChuck);
			pChuck += pHeader->nLen - sizeof(ChunkHeader);
			break;
		default:
			pChuck += pHeader->nLen - sizeof(ChunkHeader);
			break;
		}
	}
}

bool CModel3ds::Load(const char* pFilename)
{
	// 
	this->CleanUp();
	// ļ
	ifstream inputFile(pFilename, ios::in | ios::binary | ios::nocreate);
	if (inputFile.fail()) {
		cout<<"ļ!"<<endl;
		return false;
	}
	// ȡļС
	inputFile.seekg(0, ios::end);
	UINT32 nFilesize = inputFile.tellg();
	inputFile.seekg(0, ios::beg);
	// 岢
	BYTE* const pBuffer = new BYTE[nFilesize];
	inputFile.read(pBuffer, nFilesize);
	inputFile.close();
	// Ļָ
	const BYTE* pPtr = pBuffer;
	// ʶǷȷ
	CModel3ds::ChunkHeader *pHeader = (CModel3ds::ChunkHeader*)pPtr;
	if (pHeader->nId != 0x4D4D) {
		cout<<"ļʽ!"<<endl;
		delete[] pBuffer;
		return false;
	}

	// ʼݹ鴦Chunk
	this->ProcessChunk(pPtr, pHeader->nLen);

	delete[] pBuffer;

	return true;
}

void CModel3ds::Draw(bool bUseMaterail)
{
	// е
	for(int i=0; i<m_vObjects.size(); i++)
	{
		// 
		Object *pObject = &m_vObjects[i];
		// 
		Material *pMaterial = (bUseMaterail && pObject->nMaterialId != -1) ?
			(&m_vMaterials[pObject->nMaterialId]) : NULL;
		// ɫ
		Color *pColor = pMaterial ? (&pMaterial->oColor) : NULL;
		// Ƿ
		bool bUseTexture = (pMaterial && pMaterial->bHasTexture);
		// ͼԪģʽ
		::glPolygonMode(GL_FRONT_AND_BACK, (bUseMaterail?GL_FILL:GL_LINE));
		// Ĭɫ
		::glColor3ub(255, 255, 255);

		if(bUseTexture)
		{
			// ӳ
			::glEnable(GL_TEXTURE_2D);
			// ʹû
			::glEnableClientState(GL_TEXTURE_COORD_ARRAY);
			// 󶨶ӦԪ
			::glBindTexture(GL_TEXTURE_2D, pMaterial->glTexture);
		}
		else
		{
			// رӳ
			::glDisable(GL_TEXTURE_2D);
			// ʹû
			::glDisableClientState(GL_TEXTURE_COORD_ARRAY);
		}

		if(1){

			if(bUseTexture)
			{
				// 
				::glTexCoordPointer(2, GL_FLOAT, 0, (float*)pObject->pTexVerts);
			}
			else if (pColor)
			{
				::glColor3ub(pColor->r, pColor->g, pColor->b);
			}
			else
			{
				::glColor3ub(255, 255, 255);
			}

			// ʹö㻺
			::glEnableClientState(GL_VERTEX_ARRAY);
			::glVertexPointer(3, GL_FLOAT, 0, (float*)pObject->pVerts);

			::glDrawElements(GL_TRIANGLES, pObject->nTriCount*3, GL_UNSIGNED_SHORT, (UINT16*)pObject->pTriangles);
		}
		else
		{
			// е
			for(int j=0; j<pObject->nTriCount; j++)
			{	
				// ö
				UINT16 index[3] = {
					pObject->pTriangles[j].a,
					pObject->pTriangles[j].b,
					pObject->pTriangles[j].c // ϰ߷Ŷһ ^_^!!
				};

				// 
				::glBegin(GL_TRIANGLES);
					for (int k=0; k<3; k++)
					{
						if(bUseTexture)
						{
							::glTexCoord2f(pObject->pTexVerts[index[k]].x, pObject->pTexVerts[index[k]].y);
						}
						else if (pColor)
						{
							::glColor3ub(pColor->r, pColor->g, pColor->b);
						}
						else
						{
							::glColor3ub(255, 255, 255);
						}
						::glVertex3f(pObject->pVerts[index[k]].x, pObject->pVerts[index[k]].y, pObject->pVerts[index[k]].z);
					}
				::glEnd();
			}
		}
	}
}
