//////////////////////////////////////////////////////////////////////
//File: Model3ds.h
//Create: 2008-1-20
//Author: Kong
//E-Mail: bps-kong@hotmail.com
//Weblog: http://bps-kong.cnblogs.com
//Desc: һ3DSģࡣʵѾУҾʵֵùڸӡ
//      ҲõķʽеXMLPUSHģ͡
//
//Copyleft: ɴ뱣(ע͡˵ĵ)
//////////////////////////////////////////////////////////////////////

#ifndef __CMODEL3DS_H__
#define __CMODEL3DS_H__

// byte-align structures
#ifdef _MSC_VER
	#pragma pack(push, packing)
	#pragma pack(1)
	#define PACK_STRUCT
#elif defined( __GNUC__)
	#define PACK_STRUCT __attribute__((packed))
#else
	#error you must byte-align these structures with the appropriate compiler directives
#endif
// GLUT
#include <WINDOWS.H>
#include "glut.h"
// STD C++
#include <fstream.h>
#include <vector>

class CModel3ds {

public:

	typedef unsigned char BYTE;
	typedef unsigned short UINT16;
	typedef unsigned int UINT32;

	struct Vector2 
	{
		float x;
		float y;
	};

	struct Vector3 
	{
		float x;
		float y;
		float z;
	};

	struct Triangle
	{
		UINT16 a;
		UINT16 b;
		UINT16 c;
	};

	struct Color
	{
		BYTE r;
		BYTE g;
		BYTE b;
	};

	struct Material
	{
		char csName[255];		// 
		Color oColor;			// ɫ
		bool bHasTexture;		// Ƿ
		GLuint glTexture;		// Ԫ
	};

	struct Object
	{
		char csName[11];		// 10ֽڵ+0
		UINT16 nMaterialId;		// (-1ʾ޲)
		UINT16 nVertCount;		// 
		//UINT16 nTexVertCount;	// (ڶ)
		UINT16 nTriCount;		// ĸ
		Vector3 *pVerts;		// б
		Vector2 *pTexVerts;		// б
		Triangle *pTriangles;	// б˵б(Ӧһ)
	};

	struct ChunkHeader
	{
		UINT16 nId;
		UINT32 nLen;
	} PACK_STRUCT;

public:
	CModel3ds();
	~CModel3ds();
	bool Load(const char* pFilename);
	void Draw(bool bUseMaterail);
private: // ֹһЩ -_-||
	CModel3ds& operator=(const CModel3ds& src);
	CModel3ds(const CModel3ds& src);
private:
	int GetMaterialName(const BYTE* const &pName);
	void GetMaterialColor(const BYTE* const &pBuf);
	void GetMaterialTexture(const BYTE* const &pFilename);
	int GetObjectName(const BYTE* const &pName);
	void GetObjectMaterial(const BYTE* const &pName);
	void GetObjectVerts(const BYTE* const &pBuf);
	void GetObjectTriangles(const BYTE* const &pBuf);
	void GetObjectTexVerts(const BYTE* const &pBuf);
	void ProcessChunk(const BYTE* &pChuck, UINT32 nLen);
	bool BuildTexture(const char *pFilename, GLuint &glTexture);
	void CleanUp();
private:
	std::vector<Material> m_vMaterials;
	std::vector<Object> m_vObjects;

}; // CModel3ds

#endif // __CMODEL3DS_H__
