//////////////////////////////////////////////////////////////////////
//File: ModelViewer.cpp
//Create: 2008-1-20
//Author: Kong
//E-Mail: bps-kong@hotmail.com
//Weblog: http://bps-kong.cnblogs.com
//Desc: CGlutApp࣬ʵһضӦ -- Сһģ͹۲
//
//Copyleft: ɴ뱣(ע͡˵ĵ)
//////////////////////////////////////////////////////////////////////

#include "ModelViewer.h"

CModelViewer::CModelViewer()
{
	m_xrot = 0.0f;
	m_yrot = 0.0f;
	m_zrot = 0.0f;
	m_xoff = 0.0f;
	m_yoff = 0.0f;
	m_zoff = 0.0f;
	m_bLfDown = false;
	m_bRtDown = false;
	m_bMdDown = false;
	m_bAutoRot = false;
	m_bUseMaterail = true;
}

CModelViewer::~CModelViewer()
{
}

void CModelViewer::MouseProc(int button, int state, int x, int y)
{
	m_xold = x;
	m_yold = y;
	switch (button)
	{
	case GLUT_LEFT_BUTTON:
		m_bLfDown = (state==GLUT_DOWN);
		break;
	case GLUT_MIDDLE_BUTTON:
		m_bMdDown = (state==GLUT_DOWN);
		break;
	case GLUT_RIGHT_BUTTON:
		m_bRtDown = (state==GLUT_DOWN);
		break;
	}
}

void CModelViewer::MotionProc(int x, int y)
{
	if(m_bLfDown)
	{
		m_xrot += y-m_yold;
		m_yrot += x-m_xold;
		::glutPostRedisplay();
	}
	if(m_bMdDown)
	{
		m_xoff += x-m_xold;
		m_yoff -= y-m_yold;
		::glutPostRedisplay();
	}
	if(m_bRtDown)
	{
		m_zoff += y-m_yold;
		m_zrot += x-m_xold;
		::glutPostRedisplay();
	}
	m_xold = x;
	m_yold = y;
}

void CModelViewer::KeyboardProc(unsigned char key, int x, int y)
{
	// ģļѡҪ
	// Ҽдһ㲻ƽ̨APIĴ 
	static char tmpfile[] = {0x31,0x2e,0x33,0x64,0x73,0x00};

	switch (key)
	{
	case ' ':
		m_bAutoRot = !m_bAutoRot;
		break;
	case 't':
		m_bUseMaterail = !m_bUseMaterail;
		break;
	case '0':
	case '1':
	case '2':
	case '3':
	case '4':
	case '5':
	case '6':
	case '7':
	case '8':
	case '9':
		tmpfile[0] = key;
		m_oModel.Load(tmpfile);
		break;
	default:
		break;
	}
}

void CModelViewer::DisplayProc(void)
{
	// ֡
	::glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);

	// 󲢱任
	::glLoadIdentity();
	::glTranslatef(0.0, 0.0, -200.0);
	::glTranslatef(m_xoff, m_yoff, m_zoff);
	::glRotatef(m_xrot, 1.0, 0.0, 0.0);
	::glRotatef(m_yrot, 0.0, 1.0, 0.0);
	::glRotatef(m_zrot, 0.0, 0.0, 1.0);

	// Ⱦģ
	m_oModel.Draw(m_bUseMaterail);

	// ֡
	::glutSwapBuffers();
	// ԶתҪ½Ƕ
	if (m_bAutoRot)
	{
		m_xrot += 0.01f;
		m_yrot += 0.5f;
		m_zrot += 0.5f;
	}
	// ػϢ
	::glutPostRedisplay();
}

// end of file