//////////////////////////////////////////////////////////////////////
//File: WorldViewer.cpp
//Create: 2008-1-25
//Author: Kong
//E-Mail: bps-kong@hotmail.com
//Weblog: http://bps-kong.cnblogs.com
//Desc: CModelViewer࣬ʵһضӦ -- Сһ۲
//
//Copyleft: ɴ뱣(ע͡˵ĵ)
//////////////////////////////////////////////////////////////////////

#include "WorldViewer.h"
#include "math.h"

CWorldViewer::CWorldViewer()
{
	m_fStep = 2.5f;
}

CWorldViewer::~CWorldViewer()
{
}

void CWorldViewer::Init(void)
{
	CGlutApp::Init();
	m_oGround.Load("ground.3ds");
}

void CWorldViewer::MotionProc(int x, int y)
{
	if(m_bLfDown)
	{
		m_yrot += x-m_xold;
		m_xrot += y-m_yold;
		if (m_xrot > +90.0f) m_xrot = +90.0f;
		if (m_xrot < -90.0f) m_xrot = -90.0f;
		::glutPostRedisplay();
	}
	if(m_bMdDown)
	{
		m_zrot += x-m_xold;
		::glutPostRedisplay();
	}
	if(m_bRtDown)
	{
		m_xoff -= sin(DEG2RAD(m_yrot)) * (y-m_yold);
		m_zoff += cos(DEG2RAD(m_yrot)) * (y-m_yold);
		::glutPostRedisplay();
	}
	m_xold = x;
	m_yold = y;
}

void CWorldViewer::KeyboardProc(unsigned char key, int x, int y)
{

	// ȴ
	CModelViewer::KeyboardProc(key, x, y);

	// ֵ ^_^
	switch (key)
	{
	case 'a':
		m_xoff += cos(DEG2RAD(m_yrot)) * m_fStep;
		m_zoff += sin(DEG2RAD(m_yrot)) * m_fStep;
		::glutPostRedisplay();
		break;
	case 'd':
		m_xoff -= cos(DEG2RAD(m_yrot)) * m_fStep;
		m_zoff -= sin(DEG2RAD(m_yrot)) * m_fStep;
		::glutPostRedisplay();
		break;
	case 'w':
		m_xoff -= sin(DEG2RAD(m_yrot)) * m_fStep;
		m_zoff += cos(DEG2RAD(m_yrot)) * m_fStep;
		::glutPostRedisplay();
		break;
	case 's':
		m_xoff += sin(DEG2RAD(m_yrot)) * m_fStep;
		m_zoff -= cos(DEG2RAD(m_yrot)) * m_fStep;
		::glutPostRedisplay();
		break;
	default:
		break;
	}
}

void CWorldViewer::DisplayProc(void)
{
	// ֡
	::glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);

	// 󲢱任
	::glLoadIdentity();
	::glRotatef(m_xrot, 1.0, 0.0, 0.0);
	::glRotatef(m_yrot, 0.0, 1.0, 0.0);
	::glRotatef(m_zrot, 0.0, 0.0, 1.0);
	::glTranslatef(m_xoff, 0.0, m_zoff);

	// 
	m_oGround.Draw(false);

	// Ⱦģ
	m_oModel.Draw(m_bUseMaterail);

	// ֡
	::glutSwapBuffers();
	// ػϢ
	::glutPostRedisplay();
}

// end of file